/* Copyright (C) 2004-2006 The SSI Project. All rights reserved.
   http://ssi.is.s.u-tokyo.ac.jp/

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.  See the LICENSE file for the precise
   terms and conditions for the use of this software.
*/

#ifndef __LIS_MATVEC_H__
#define __LIS_MATVEC_H__

#define LIS_MATVEC_SENDRECV \
		if( (A->np+A->pad)>(X->np+X->pad) ) \
		{ \
			X->value = (LIS_SCALAR *)lis_realloc(X->value,(A->np+A->pad)*sizeof(LIS_SCALAR)); \
			if( X->value==NULL ) \
			{ \
				LIS_SETERR_MEM((A->np+A->pad)*sizeof(LIS_SCALAR)); \
				return LIS_ERR_OUT_OF_MEMORY; \
			} \
			X->np  = A->np; \
			X->pad = A->pad; \
			x = X->value; \
		} \
		lis_send_recv(A->commtable,x);

#define LIS_MATVEC_REALLOC \
		if( (A->np+A->pad)>(X->np+X->pad) ) \
		{ \
			X->value = (LIS_SCALAR *)lis_realloc(X->value,(A->np+A->pad)*sizeof(LIS_SCALAR)); \
			if( X->value==NULL ) \
			{ \
				LIS_SETERR_MEM((A->np+A->pad)*sizeof(LIS_SCALAR)); \
				return LIS_ERR_OUT_OF_MEMORY; \
			} \
			X->np  = A->np; \
			X->pad = A->pad; \
			x = X->value; \
		} \

#define LIS_MATVEC_REDUCE0 \
		if( (A->np+A->pad)>(Y->np+Y->pad) ) \
		{ \
			Y->value = (LIS_SCALAR *)lis_realloc(Y->value,(A->np+A->pad)*sizeof(LIS_SCALAR)); \
			if( Y->value==NULL ) \
			{ \
				LIS_SETERR_MEM((A->np+A->pad)*sizeof(LIS_SCALAR)); \
				return LIS_ERR_OUT_OF_MEMORY; \
			} \
			Y->np  = A->np; \
			Y->pad = A->pad; \
			y      = Y->value; \
		}

#define LIS_MATVEC_REDUCE lis_reduce(A->commtable,y)

typedef void (*LIS_MATVEC_XXX)(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
typedef void (*LIS_MATVEC_XXXP)(LIS_MATRIX A, LIS_VECTOR X, LIS_VECTOR Y);

#ifdef __cplusplus
extern "C"
{
#endif
	/*******************/
	/* CRS             */
	/*******************/
	extern LIS_MATVEC_XXX lis_matvec_crs_xxx[1][8];
	extern LIS_MATVEC_XXXP lis_matvec_crs_xxxP[1][8];
	extern void lis_matvec_crs_u1_1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_crs_u1_2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_crs_u1_3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_crs_u1_4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_crs_u1_5(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_crs_u1_6(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_crs_u1_7(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_crs_u1_8(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_crs_u1_1P(LIS_MATRIX A, LIS_VECTOR X, LIS_VECTOR Y);
	extern void lis_matvec_crs_u1_2P(LIS_MATRIX A, LIS_VECTOR X, LIS_VECTOR Y);
	extern void lis_matvec_crs_u1_3P(LIS_MATRIX A, LIS_MSCALAR x[], LIS_MSCALAR y[]);
	extern void lis_matvec_crs_u1_4P(LIS_MATRIX A, LIS_MSCALAR x[], LIS_MSCALAR y[]);
	extern void lis_matvec_crs_u1_5P(LIS_MATRIX A, LIS_MSCALAR x[], LIS_MSCALAR y[]);
	extern void lis_matvec_crs_u1_6P(LIS_MATRIX A, LIS_MSCALAR x[], LIS_MSCALAR y[]);
	extern void lis_matvec_crs_u1_7P(LIS_MATRIX A, LIS_MSCALAR x[], LIS_MSCALAR y[]);
	extern void lis_matvec_crs_u1_8P(LIS_MATRIX A, LIS_MSCALAR x[], LIS_MSCALAR y[]);
	extern void lis_matvect_crs(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_crs_mp(LIS_MATRIX A, LIS_VECTOR X, LIS_VECTOR Y);
	extern void lis_matvect_crs_mp2(LIS_MATRIX A, LIS_VECTOR X, LIS_VECTOR Y);
	/*******************/
	/* CCS             */
	/*******************/
	extern void lis_matvec_ccs(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_ccs(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_ccs_u1_1P(LIS_MATRIX A, LIS_VECTOR X, LIS_VECTOR Y);
	extern void lis_matvect_ccs_u1_2P(LIS_MATRIX A, LIS_VECTOR X, LIS_VECTOR Y);
	extern void lis_matvec_ccs_mp(LIS_MATRIX A, LIS_VECTOR X, LIS_VECTOR Y);
	extern void lis_matvec_ccs_mp2(LIS_MATRIX A, LIS_VECTOR X, LIS_VECTOR Y);
	/*******************/
	/* MSR             */
	/*******************/
	extern void lis_matvec_msr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_msr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	/*******************/
	/* ELL             */
	/*******************/
	extern void lis_matvec_ell(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_ell(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	/*******************/
	/* DIA             */
	/*******************/
	extern void lis_matvec_dia(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_dia(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	/*******************/
	/* JDS             */
	/*******************/
	extern void lis_matvec_jds(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u7_1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_jds(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	/*******************/
	/* DNS             */
	/*******************/
	extern void lis_matvec_dns(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_dns(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	/*******************/
	/* COO             */
	/*******************/
	extern void lis_matvec_coo(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_coo(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	/*******************/
	/* VBR             */
	/*******************/
	extern void lis_matvec_vbr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_vbr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	/*******************/
	/* BSR             */
	/*******************/
	extern LIS_MATVEC_XXX lis_matvec_bsr_xxx[4][4];
	extern void lis_matvec_bsr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_1x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_1x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_1x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_1x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_2x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_2x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_2x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_2x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_3x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_3x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_3x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_3x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_4x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_4x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_4x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsr_4x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_bsr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	/*******************/
	/* BSC             */
	/*******************/
	extern LIS_MATVEC_XXX lis_matvec_bsc_xxx[4][4];
	extern void lis_matvec_bsc(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_1x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_1x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_1x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_1x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_2x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_2x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_2x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_2x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_3x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_3x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_3x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_3x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_4x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_4x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_4x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvec_bsc_4x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	extern void lis_matvect_bsc(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);

#ifdef __cplusplus
}
#endif

#endif
